<template>
    <div class="relative flex flex-row lg:mt-4">
      <div class="carousel" :style="`width:${width};height:${height}`">
          <slot/>
      </div>
        <a class="rounded-full flex absolute left-0 mt-40 -ml-6 bg-gray-200 justify-center items-center bg-opacity-50 w-12 h-12 hover:bg-opacity-100" @click="changeSlide(-1)" href="#">
          <svg fill="currentColor" class="fill-current text-indigo-700 inline-block h-5 w-5" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 11 18">
            <path transform="rotate(90) translate(0, -11)" d="M2.1 0L0 2.1 9 11l9-8.9L15.9 0 9 6.8 2.1 0z"></path>
          </svg>
        </a>
        <a href="#" class="rounded-full flex absolute right-0 -mr-6 mt-40 bg-gray-200 justify-center items-center bg-opacity-50 w-12 h-12 hover:bg-opacity-100" @click="changeSlide(1)">
          <svg fill="currentColor" class="fill-current text-indigo-700 inline-block h-5 w-5" viewBox="0 0 11 18">
            <path transform="rotate(-90) translate(-18, 0)" d="M2.1 0L0 2.1 9 11l9-8.9L15.9 0 9 6.8 2.1 0z"></path>
            </svg>
        </a>
        <!-- <a class="next" @click="changeSlide(1)" href="#">Next &#10095;</a> -->
        <div class="absolute flex justify-center w-full bottom-0">
          <div v-for="(slide, index) in slides" class="carousel-controls" :key="index">
            <a :class="`${element}-${index}`" @click="goToSlide(index)">Go to slide -> {{ index }}</a>
          </div>
        </div>
    </div>
</template>
<script>
export default {
  props: ['width', 'height', 'index', 'element', 'dots'],
  data() {
    return {
      autoPlay: null,
      currentIndex: 0,
      carousel: null
    };
  },

  mounted() {
    this.$nextTick(() => {
      this.carousel = document.querySelector('.carousel')
      if (this.dots) this.$el.querySelector(`.${this.element}-0`).classList.add('is-active')
      const sections = [...document.querySelectorAll(".carousel-slide")];

      let options = {
        rootMargin: "0px",
        threshold: 0.25
      };

      const callback = (entries, observer) => {
        entries.forEach(entry => {
          const { target } = entry;
          if (entry.intersectionRatio >= 0.25) {
            this.$el.querySelector(`.${this.element}-${target.getAttribute('index')}`).classList.add('is-active')
            target.classList.add("is-active");
          } else {
            target.classList.remove("is-active");
            this.$el.querySelector(`.${this.element}-${target.getAttribute('index')}`).classList.remove('is-active')
          }
        });
      };

      const carouselControls = [...this.$el.querySelectorAll('.carousel-controls a')]
      const observer = new IntersectionObserver(callback, options);

      sections.forEach((section, index) => {
        observer.observe(section);
      });

      // this.carousel.addEventListener('scroll', this.debounce(() => {
      //   let index = Math.round((this.carousel.scrollLeft / this.carousel.scrollWidth) * this.slides.length)

      //   this.setActive(index)
      // }, 200))

      this.startSlide();
    })
  },

  methods: {
    debounce(func, ms) {
      let timeout
      return () => {
        clearTimeout(timeout)
        timeout = setTimeout(() => {
          timeout = null
          func()
        }, ms);
      }
    },

    setActive(index) {
      this.slides.forEach((slide, i) => {
        !!(i === index) ? this.$el.querySelector(`.${this.element}-${i}`).classList.add('is-active') : this.$el.querySelector(`.${this.element}-${i}`).classList.remove('is-active')
      })
    },

    goToSlide(index) {
      const scrollLeft = Math.floor(this.carousel.scrollWidth * (index / this.slides.length))
      this.carousel.scrollTo({ left: scrollLeft, top: 0, behavior: 'smooth' })
      this.setActive(index)
    },

    startSlide() {
      this.autoPlay = setInterval(() => {
        if (parseInt(this.carousel.scrollWidth - this.carousel.offsetWidth) === parseInt(this.carousel.scrollLeft))
        {
          clearInterval(this)
          // this.carousel.scrollTo(0, 0)
        } else {
          this.changeSlide(1)
        }
      }, 5000)
    },

    changeSlide(delta) {
      // const carousel = document.querySelector(".carousel")
      const width = this.carousel.offsetWidth
      if (delta === -1 && this.carousel.scrollLeft === 0) {
        this.carousel.scrollTo({ left: this.carousel.scrollWidth, top: 0, behavior: 'smooth' })
      } else if (delta === 1 && parseInt(this.carousel.scrollWidth - this.carousel.offsetWidth) === parseInt(this.carousel.scrollLeft)){
        this.carousel.scrollTo({ left: 0, top: 0, behavior: 'smooth' })
      } else {
        this.carousel.scrollTo({ left: this.carousel.scrollLeft + width * delta, top: 0, behavior: 'smooth' })
      }
    },

    next() {
      // this.currentIndex += 1;
      this.$emit('next')
    },
    prev() {
      // this.currentIndex -= 1;
      this.$emit('prev')
    }
  },

  computed: {
    slides() {
      return this.$store.state.bannerHero
    }
  }
};
</script>

<style lang="postcss" scoped>
/*  */
  .carousel {
    @apply flex relative overflow-y-hidden overflow-x-scroll;
    scroll-behavior: smooth;
    scroll-snap-type: x mandatory;
    scroll-snap-stop: always;
    -webkit-overflow-scrolling: touch;
  }

   .carousel > .carousel-slide {
      @apply flex align-middle items-center justify-center opacity-0;
      flex: 1 0 100%;
      scroll-snap-align: start;
  }

  .carousel > .carousel-slide.is-active {
    opacity: 1;
    transition: opacity 1500ms;
  }

  .carousel::-webkit-scrollbar {
    display: none;
  }

  .carousel-controls {
    text-align: center;
  }
  .carousel-controls a {
    width: 10px;
    height: 10px;
    max-width: 10px;
    margin: 0 3px;
    display: inline-block;
    overflow: hidden;
    text-indent: -9999px;
    border-radius: 100%;
    background: #aaa;
  }
  .carousel-controls a:hover,
  .carousel-controls a:focus {
    background: #ddd;
  }
  .carousel-controls a.is-active {
    background: #4c51bf;
  }


</style>
